SystemOrganization addCategory: #'Seaside-Email'!
SystemOrganization addCategory: #'Seaside-Email-Configuration'!

!GRPackage class methodsFor: '*seaside-email' stamp: 'lr 2/17/2010 15:19'!
seasideEmail
	^ self new
		name: 'Seaside-Email';
		description: 'Contains convenience classes for sending of emails and preventing header injections.';
		addDependency: 'Seaside-Core';
		url: #seasideUrl;
		yourself! !

WAObject subclass: #WAEmailBody
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Email'!

WAEmailBody subclass: #WAStringEmailBody
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Email'!

!WAStringEmailBody class methodsFor: 'private' stamp: 'lr 7/25/2011 19:50'!
convertCrLfToCrIn: aString
	^ aString
		copyReplaceAll: (String with: Character cr with: Character lf)
		with: (String with: Character cr)! !

!WAStringEmailBody class methodsFor: 'private' stamp: 'lr 7/25/2011 19:50'!
splitIntoLines: aString
	^ Array streamContents: [ :stream |
		| cr start |
		cr := Character cr.
		start := 1.
		1 to: aString size do: [ :index |
			(aString at: index) = cr ifTrue: [
				stream nextPut: (aString copyFrom: start to: index - 1).
				start := index + 1 ] ].
			start <= (aString size + 1) ifTrue: [ 
				stream nextPut: (aString copyFrom: start to: aString size) ] ]! !

!WAStringEmailBody class methodsFor: 'private' stamp: 'lr 7/25/2011 19:50'!
splitString: aString intoChunksNoLongerThan: anInteger
	^ Array streamContents: [ :stream |
		self
			splitString: aString
			intoChunksNoLongerThan: anInteger
			into: stream ]! !

!WAStringEmailBody class methodsFor: 'private' stamp: 'pmm 11/4/2008 11:14'!
splitString: aString intoChunksNoLongerThan: anInteger into: aStream
	| space lastSpaceIndex toScan |
	space := Character space.
	toScan := aString size min: anInteger + 1.
	lastSpaceIndex := 0.
	1 to: toScan do: [ :index |
		(aString at: index) = space ifTrue: [
			lastSpaceIndex := index ] ].
	
	lastSpaceIndex = 0
		ifTrue: [
			lastSpaceIndex := aString size min: anInteger.
			aStream nextPut: (aString copyFrom: 1 to: lastSpaceIndex) ]
		ifFalse: [
			aStream nextPut: (aString copyFrom: 1 to: lastSpaceIndex - 1) ].
		
	lastSpaceIndex < aString size ifTrue: [
		self
			splitString: (aString copyFrom: lastSpaceIndex + 1 to: aString size)
			intoChunksNoLongerThan: anInteger
			into: aStream ]! !

!WAStringEmailBody class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 19:50'!
string: aString
	^ self new
		string: (self convertCrLfToCrIn: aString);
		yourself! !

!WAStringEmailBody class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 19:50'!
string: aString lineLength: anInteger
	| string |
	string := String streamContents: [ :stream |
		| lines |
		lines := self splitIntoLines: (self convertCrLfToCrIn: aString).
		lines do: [ :each |
			each size <= anInteger
				ifTrue: [ stream nextPutAll: each ]
				ifFalse: [
					(self splitString: each intoChunksNoLongerThan: anInteger)
						do: [ :chunk | stream nextPutAll: chunk ]
						separatedBy: [ stream nextPut: Character cr ] ] ]
			separatedBy: [ stream nextPut: Character cr ] ].
	^ self new
		string: string;
		yourself! !

!WAStringEmailBody methodsFor: 'accessing' stamp: 'jf 9/30/2009 01:10'!
greaseString
	^ self string! !

!WAStringEmailBody methodsFor: 'accessing' stamp: 'pmm 8/31/2008 15:29'!
string
	^ string! !

!WAStringEmailBody methodsFor: 'accessing' stamp: 'pmm 8/31/2008 15:29'!
string: aString
	string := aString! !

WAObject subclass: #WAEmailMessage
	instanceVariableNames: 'to from cc bcc subject headers body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Email'!

!WAEmailMessage class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 19:48'!
from: aFromEmailAddress to: aToEmailAddress subject: aString
	^ self new
		from: aFromEmailAddress;
		addTo: aToEmailAddress;
		subject: aString;
		yourself! !

!WAEmailMessage class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 19:48'!
from: aFromEmailAddress toAll: aCollectionOfEmailAddress subject: aString
	^ self new
		from: aFromEmailAddress;
		addAllTo: aCollectionOfEmailAddress;
		subject: aString;
		yourself! !

!WAEmailMessage methodsFor: 'adding' stamp: 'pmm 8/31/2008 13:44'!
addAllTo: aCollectionOfEmailAddress
	aCollectionOfEmailAddress do: [ :each |
		self addTo: each ]! !

!WAEmailMessage methodsFor: 'adding' stamp: 'lr 7/25/2011 20:01'!
addBcc: anEmailAddress
	^ self bcc add: anEmailAddress! !

!WAEmailMessage methodsFor: 'adding' stamp: 'lr 7/25/2011 20:02'!
addCc: anEmailAddress
	^ self cc add: anEmailAddress! !

!WAEmailMessage methodsFor: 'adding' stamp: 'lr 7/25/2011 20:02'!
addTo: anEmailAddress
	^ self to add: anEmailAddress! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
bcc
	^ bcc! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
body
	^ body! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
body: anObject
	body := anObject! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
cc
	^ cc! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
from
	^ from! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
from: anObject
	from := anObject! !

!WAEmailMessage methodsFor: 'adding' stamp: 'lr 7/25/2011 20:00'!
headerAt: aKeyString put: aValueString
	^ self headers at: aKeyString put: aValueString! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
headers
	^ headers! !

!WAEmailMessage methodsFor: 'initialization' stamp: 'jf 9/30/2009 00:32'!
initialize
	super initialize.
	to := OrderedCollection new.
	cc := OrderedCollection new.
	bcc := OrderedCollection new.
	headers := Dictionary new.
	self 
		headerAt: 'Date'
		put: (GRPrinter rfc822 print: DateAndTime now)! !

!WAEmailMessage methodsFor: 'private' stamp: 'pmm 10/7/2010 11:21'!
plainMessage
	^ String streamContents: [ :stream | 
		self 
			renderAddress: self from
			withHeader: 'From: '
			on: stream.
		self to do: [ :each | 
			self 
				renderAddress: each
				withHeader: 'To: '
				on: stream ].
		self cc do: [ :each | 
			self 
				renderAddress: each
				withHeader: 'Cc: '
				on: stream ].
		self bcc do: [ :each | 
			self 
				renderAddress: each
				withHeader: 'Bcc: '
				on: stream ].
		stream
			nextPutAll: 'Subject: ';
			nextPutAll: self subject;
			nextPut: Character cr.
			
		self headers keysAndValuesDo: [ :key :value |
			stream 
				nextPutAll: key greaseString; nextPut: $:; nextPut: Character space;
				nextPutAll: value greaseString; nextPut: Character cr].
		
		stream nextPut: Character cr. "let body start"
		
		self body isNil ifFalse: [ stream nextPutAll: self body greaseString ] ]! !

!WAEmailMessage methodsFor: 'private' stamp: 'dkh 11/23/2009 15:55'!
recipients
	^ self to , self cc , self bcc collect: [ :each | each greaseString ]! !

!WAEmailMessage methodsFor: 'private' stamp: 'pmm 10/13/2010 21:27'!
recipientsAddresses
	^ Array streamContents: [ :stream |
		self to do: [ :each |
			stream nextPut: each address ].
		self cc do: [ :each |
			stream nextPut: each address ].
		self bcc do: [ :each |
			stream nextPut: each address ] ]! !

!WAEmailMessage methodsFor: 'private' stamp: 'jf 9/30/2009 01:10'!
renderAddress: anEmailAddress withHeader: aString on: aStream 
	aStream
		nextPutAll: aString;
		nextPutAll: anEmailAddress greaseString;
		nextPut: Character cr! !

!WAEmailMessage methodsFor: 'actions' stamp: 'dkh 11/23/2009 15:03'!
send
	GRPlatform current seasideDeliverEmailMessage: self! !

!WAEmailMessage methodsFor: 'convenience' stamp: 'pmm 8/31/2008 15:32'!
setStringBody: aString wrap: aBoolean
	self body: (aBoolean
		ifTrue: [ WAStringEmailBody string: aString lineLength: 80 ]
		ifFalse: [ WAStringEmailBody string: aString ])! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
subject
	^ subject! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
subject: anObject
	subject := anObject! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
to
	^ to! !

WASystemConfiguration subclass: #WAEmailConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Email-Configuration'!

!WAEmailConfiguration methodsFor: 'description' stamp: 'topa 10/11/2010 16:55'!
describeOn: config 
	(config string: #smtpServer)
		group: #email;
		label: 'SMTP Server';
		comment: 'The hostname of the SMTP Server to use for sending Emails'.
	(config integer: #smtpPort)
		beAdvanced;
		group: #email;
		label: 'SMTP Port';
		comment: 'The port of the SMTP Server to use for sending Emails.';
		default: 25.
	(config string: #smtpUsername)
		beAdvanced;
		group: #email;
		label: 'SMTP Server user name';
		comment: 'The user name used to log into the SMTP Server to use for sending Emails'.
	(config string: #smtpPassword)
		beAdvanced;
		group: #email;
		label: 'SMTP Server password';
		comment: 'The password used to log into the SMTP Server to use for sending Emails'.! !

!GRPlatform methodsFor: '*seaside-email' stamp: 'dkh 11/25/2009 11:48'!
seasideDeliverEmailMessage: aWAEmailMessage

	self subclassResponsibility! !

!GRPlatform methodsFor: '*seaside-email' stamp: 'pmm 6/19/2011 16:40'!
seasideHandlerPreferenceAt: aKey ifAbsent: aBlock
		
	^ [ WACurrentRequestContext value application preferenceAt: aKey ] "in a Seaside context"
		on: WARequestContextNotFound, WAAttributeNotFound 
		do: [ :ex | aBlock value ] "not in a Seaside context, treat as absent"! !

!GRPlatform methodsFor: '*seaside-email' stamp: 'topa 10/13/2010 12:51'!
seasideSmtpPassword

	"^ self seasideApplicationPreferenceAt: #smtpPassword ifAbsent: [?]"
	self subclassResponsibility! !

!GRPlatform methodsFor: '*seaside-email' stamp: 'topa 10/13/2010 12:51'!
seasideSmtpPort

	"^ self seasideApplicationPreferenceAt: #smtpPort ifAbsent: [?]"
	self subclassResponsibility! !

!GRPlatform methodsFor: '*seaside-email' stamp: 'topa 10/13/2010 12:51'!
seasideSmtpServer
	
	"^ self seasideApplicationPreferenceAt: #smtpServer ifAbsent: [?]"
	self subclassResponsibility! !

!GRPlatform methodsFor: '*seaside-email' stamp: 'topa 10/13/2010 12:51'!
seasideSmtpUsername

	"^ self seasideApplicationPreferenceAt: #smtpUsername ifAbsent: [?]"
	self subclassResponsibility! !
